/*
Dhalias: A DreamHost Alias Widget for Mac OSX
Copyright (C) 2007  Frederic Thomas (code@dhalias.com)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

// This file was generated by Dashcode from Apple Inc.

// Globals

var frontSpinner;
var backSpinner;

var username;
var password;
var domainsIndex;

var configured;




var listDomains; // domains
var forwardDefault; 
var listEmails; // existing alias

var loadedDomains = false;

//var domainDefault;

var pX_objective;
var pX_callback;

//var step;


function frontEnabled(enabled)
{
	document.getElementById('frontSearch').disabled = (enabled == 0);
	document.getElementById('frontDomains').object.enabled = (enabled > 0);
	document.getElementById('frontForward').disabled = (enabled == 0);
	document.getElementById('frontCreate').object.enabled = (enabled > 0);	
}

function loadPrefs()
{
	if(window.widget)		// always check to make sure that you are running in Dashboard
	{
		KeyChainAccess.setAppName("Dhalias Widget");
		
		// get the preference
		// Username
		var pref = widget.preferenceForKey(makeKey("dh-username"));
		if (pref != null) {
			username = pref;
			document.getElementById("backUsername").value = username;
		}

		// Password from the KeyChain
		if (username != null && username.length != 0) {
			password = KeyChainAccess.loadPassword(username);
			document.getElementById("backPassword").value = password;
		}

		// domainsIndex
		pref = widget.preferenceForKey(makeKey("dh-domainsIndex"));
		if (pref != null) {
			domainsIndex = pref;
		}

		// listDomains
//		pref = widget.preferenceForKey(makeKey("dh-domains"));
//		if (pref != null) {
//			listDomains = decode(pref);
//			backDomains_load();
//			frontDomains_load();
//		}

		// listEmails
//		pref = widget.preferenceForKey(makeKey("dh-emails"));
//		if (pref != null) {
//			listEmails = decode(pref);
//		}

		// forwardDefault
		pref = widget.preferenceForKey(makeKey("dh-forwardDefault"));
		if (pref != null) {
			forwardDefault = pref;
			document.getElementById("backForward").value = forwardDefault;
			document.getElementById("frontForward").value = forwardDefault;
		}
	}
}

function loadDone(errorText)
{
	frontSpinner.stop();
	document.getElementById("frontError").innerText = errorText;
	
	if (errorText == "" && window.widget)
	{
		// update domain popups
		backDomains_load();
		frontDomains_load();
		
		frontEnabled(1);
		
		configured = true;
	}
}




//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    // Dashcode stuff
	setupParts();
	
	// Our stuff
	backSpinner = new ProgressIndicator(document.getElementById('backSpinner'), "./Images/Spinner.white/");
	frontSpinner = new ProgressIndicator(document.getElementById('frontSpinner'), "./Images/Spinner.white/");
	frontSearch = document.getElementById('frontSearch');
	frontDomains = document.getElementById('frontDomains');
	frontForward = document.getElementById('frontForward');
	frontCreate = document.getElementById('frontCreate');

	// Get the current version 
	var currentVersion = trim(getPlistProperty("Info", "CFBundleVersion"));
	document.getElementById('frontName').innerText = "dhalias " + currentVersion;

	frontEnabled(0);
	configured = false;

	// Prefs
	loadPrefs();
	
	// connect
	if (username && password)
	{
		frontSpinner.start();
		p1_getCookie("domains", loadDone);
	}
	else
	{
		document.getElementById("frontError").innerText = "Not configured!";
	}
}

function backRefreshButtonDone(errorText)
{
	backSpinner.stop();
	document.getElementById("backError").innerText = errorText;
	
	// Save username and password if it works!
	if (errorText == "" && window.widget)
	{
		// update domain popup
		backDomains_load();
		
		// save prefs
		//widget.setPreferenceForKey(encode(listDomains), makeKey("dh-domains"));
		//widget.setPreferenceForKey(encode(listEmails), makeKey("dh-emails"));
		widget.setPreferenceForKey(username, makeKey("dh-username"));
		KeyChainAccess.savePassword(username, password);
		
		document.getElementById("done").object.enabled = true;
		configured = true;
	}
}




function backRefreshButton(event)
{
	username = document.getElementById("backUsername").value;
	password = document.getElementById("backPassword").value;
	
	if (username && password)
	{

		document.getElementById("backError").innerText = "";

		p1_getCookie("domains", backRefreshButtonDone);
		
		var myList = document.getElementById("backDomains");
	 	for	(var i = myList.options.length; i >= 0; i--) myList.options[i] = null;

		backSpinner.start();
	}
	else
	{
		document.getElementById("backError").innerText = "Missing username or password!";
	}
}


function backRefreshKbd(event) {
	switch (event.keyCode) {
		case 13: // return
		case 3:  // enter
			backRefreshButton();
		break;
		case 9:  // tab
		break;
	}
}


function backDomains_load()
{
	var myList = document.getElementById("backDomains");
	for	(var i = myList.options.length; i >= 0; i--) myList.options[i] = null;
	
	for	(var i = 0;i<listDomains.length;i++)
	{
		if (i == 0)
		{ 
			defaultSelected = true; 
			Selected = true; 
		}
		else 
		{ 
			defaultSelected = false; 
			Selected = false; 
		}
		if (listDomains[i] == domainsIndex)
		{
			defaultSelected = true; 
			Selected = true; 
		} 
		else 
		{ 
			defaultSelected = false; 
			Selected = false;
		}
		myOption = new Option(listDomains[i], listDomains[i], defaultSelected, Selected);
		myList.options[myList.options.length] = myOption;
	}
	loadedDomains = true;
}


function callpX_callback(errorText, param1, param2)
{
	if (pX_callback != null)
	{
		pX_callback(errorText, param1, param2);
	}
}


function p1_getCookie(objective, callback)
{
//	alert("p1_getCookie()");
	pX_objective = objective;
	pX_callback = callback;

	req = new XMLHttpRequest();
	req.onreadystatechange = p1_gotCookie;
	req.open("GET", "https://panel.dreamhost.com/");
	req.send();
}


function p1_gotCookie()
{
    if (req.readyState != 4) { return; }

	if (req.status != 200) {
		alert("p1_gotCookie :\n" + req.statusText);
		callpX_callback("Can't reach panel.dreamhost.com!");
		return;
	}

	// starting the spinner in the load event does not work?
	frontSpinner.start();

	req = new XMLHttpRequest();
	req.onreadystatechange = p2_loggedIn;
	req.open("POST", "https://panel.dreamhost.com/index.cgi");
	req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
	req.send("Nscmd=Nlogin&username="+username+"&password="+password);
}


function p2_loggedIn()
{
    if (req.readyState != 4) { return; }

	if (req.status != 200) {
		alert("p2_loggedIn :\n" + req.statusText);
		callpX_callback(req.statusText);
		return;
	}

	// Look for something to confirm we're OK
	if (req.responseText.indexOf("  (Member since ") == -1)
	{
		alert("Could not find '  Member since ' in returned data!");
		callpX_callback("Cannot log in!");
		return;
	}

	req = new XMLHttpRequest();
	req.onreadystatechange = p3_gotDomains;
	req.open("GET", "https://panel.dreamhost.com/index.cgi?tree=mail.addresses&current_step=Index&next_step=New");
	req.send();
}


function p3_gotDomains()
{
    if (req.readyState != 4) { return; }

	if (req.status != 200) {
		alert("p3_gotDomains :\n" + req.statusText);
		callpX_callback(req.statusText);
		return;
	}

	var data = req.responseText
	var f1 = data.indexOf("<h1>Forward-Only Email<p>");
	if (f1 == -1)
	{
		alert("Could not find '<h1>Forward-Only Email<p>' in returned data!");
		callpX_callback("DreamHost has changed; please update me!");
		return;
	}
		
	if (pX_objective == "alias")
	{
		p4_postNewAlias();
	}
	else
	{
		// parse domain list...
		var f2 = data.indexOf('<select id="domain" name="domain">', f2);
		var f3 = data.indexOf('</select>', f2)
		
		if (f2 == -1 || f3 == -1 || f3 <= f2)
		{
			alert("Could not find '<select id=\"domain\" name=\"domain\">' in returned data!");
			callpX_callback("DreamHost has changed; please update me!");
			return;
		}
		
		f = f2;
		listDomains = new Array();
		while (f != -1 && f < f3)
		{
			var fa = data.indexOf('<option value="', f);
			var fb = data.indexOf('">', fa);
			if (fa != -1 && fb < f3) 
			{
				listDomains.push(data.substring(fa+15,fb));
			}
			f = fb;
		}
		
		if (listDomains.length > 1)
		{
			// make sure all domains are selected
			req = new XMLHttpRequest();
			req.onreadystatechange = p4_setDomainList;
			req.open("GET", "https://panel.dreamhost.com/index.cgi?tree=mail.addresses&");
			req.send();
		}
		else
		{
			// go directly to bulk request of existing emails
			p5_getBulk();
		}
	}
}


function p4_setDomainList()
{
    if (req.readyState != 4) { return; }

	if (req.status != 200) {
		alert("p4_setDomainList :\n" + req.statusText);
		callpX_callback(req.statusText);
		return;
	}

	req = new XMLHttpRequest();
	req.onreadystatechange = p4_domainList;
	req.open("POST", "https://panel.dreamhost.com/?");
	req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
	var text = "";
	for	(var i = 0;i<listDomains.length;i++)
	{
		text = text + "&domainselector=" + listDomains[i];
	}
	req.send("tree=mail.addresses&current_step=Index&next_step=DoSelector" + text);
}


function p4_domainList()
{
    if (req.readyState != 4) { return; }

	if (req.status != 200) {
		alert("p4_domainList :\n" + req.statusText);
		callpX_callback(req.statusText);
		return;
	}

	// Look for something to confirm we're OK
	if (req.responseText.indexOf(" Success!") == -1)
	{
		alert("Could not find ' Success!' in returned data!");
		callpX_callback("Cannot set domains!");
		return;
	}
	
	p5_getBulk();
}


function p5_getBulk()
{
	req = new XMLHttpRequest();
	req.onreadystatechange = p5_gotBulk;
	req.open("GET", "https://panel.dreamhost.com/index.cgi?tree=mail.addresses&current_step=Index&next_step=Bulk");
	req.send();
}


function p5_gotBulk()
{
    if (req.readyState != 4) { return; }

	if (req.status != 200) {
		alert("p5_gotBulk :\n" + req.statusText);
		callpX_callback(req.statusText);
		return;
	}

	var data = req.responseText;
	var fa = data.indexOf('<textarea name="text" id="text" class="text" wrap="off" rows="20">');
	var fb = data.indexOf('</textarea>', fa);
	if (fa == -1 || fb == -1)
	{
		alert("Could not find '<textarea>' in returned data!");
		callpX_callback("Cannot get defined emails!");
		return;
	}
	
	var rawAlias = data.substring(fa+66,fb);
	
	// alias <tab> <tab> destination <return>
	
	var f1 = 0;
	var f2 = rawAlias.indexOf("\n");
	listEmails = new Array();

	while (f2 > -1)
	{
		var rawLine = rawAlias.substring(f1, f2);

		var fr1 = rawLine.indexOf("\t");
//		var alias = rawLine.substring(0, fr1);
//		var dest = rawLine.slice(fr1+2);
		
		listEmails.push(rawLine.substring(0, fr1));
				
		f1 = f2 + 1;
		f2 = rawAlias.indexOf("\n", f1);
	}
	
	listEmails.sort();
		
	// done
	callpX_callback("");
}

//
// Function: clearContent()
// Clear the current content area.
//
function clearContent()
{
    var content = document.getElementById("content");

    if (content) {
        while (content.hasChildNodes()) {
            content.removeChild(content.firstChild);
        }
    }
	return content;
}


function frontSearch_search(what)
{
	alert("frontSearch_search(" + what + ")");
			
	frontSpinner.start();
	var content = clearContent();
		
	var th = "";
	if (what.length > 0)
	{
		for	(var i = 0;i<listEmails.length;i++)
		{
			if(listEmails[i].toLowerCase().indexOf(what) == "0")
			{
				th = th + listEmails[i] + "<br>";
			}
		}
	}
	var ulElement = document.createElement("div");
	ulElement.setAttribute("id", "entryTitle");
	ulElement.innerHTML = th;
	content.appendChild(ulElement);
	document.getElementById("scrollArea").object.refresh();
	frontSpinner.stop();
}




function openDH()
{
	widget.openURL('http://www.dreamhost.com/r.cgi?133789');
}

function showState(val, text, log)
{
//	var infoText = document.getElementById("infoText");
//	var infoIndicator = document.getElementById("infoIndicator");
//	var forwardButton = document.getElementById("forwardButton");
	
//	infoText.innerText = text;
//	infoIndicator.object.setValue(val);
//	forwardButton.object.setEnabled (val == 1);
	
	if (log)
	{
		alert(log);
	}
}


function p4_postedNewAlias()
{
    if (req.readyState != 4) { return; }

	if (req.status != 200) {
		alert("p3_postedNewAlias :\n" + req.statusText);
		showState(1, "Error");
	}

	var data = req.responseText
	var f1 = data.indexOf('<div class="successbox">');
	if (f1 > -1)
	{
		var f2 = data.indexOf('Successfully added', f1);
		var f3 = data.indexOf('</h1></div>', f2);
		
		showState(1, data.substring(f2,f3));
		
		listEmails.push(newAlias);
		listEmails.sort();
		frontSearch_search(newAlias)
		
//		frontSpinner.stop();
		
	}
	else 
	{
		alert('Could not find \"<div class=\"successbox\">\" in returned data!');
		showState(1, "Error");
	}
}

function p4_postNewAlias()
{
//	alert("p4_postNewAlias()");
	// get fields
	var alias = document.getElementById("frontSearch").value;
	var domain = frontDomains.object.getValue();
	var forward = document.getElementById("frontForward").value;
	newAlias = alias + "@" + domain;
	objective = "";
	if (alias && domain && forward)
	{
		// try to connect
		req = new XMLHttpRequest();
		req.onreadystatechange = p4_postedNewAlias;
		req.open("POST", "https://panel.dreamhost.com/?");
		req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
		req.send("tree=mail.addresses&current_step=New&next_step=NewFinal&dest=forward&alias="+alias+"&domain="+domain+"&addresses="+forward);
	}
}




function frontCreateButton()
{
	var alias = document.getElementById("frontSearch").value;
	var domain = frontDomains.object.getValue();
	var forward = document.getElementById("frontForward").value;

	if (alias && domain && forward)
	{	
		//showState(2, "Posting alias...");
		frontSpinner.start();
		p1_getCookie("alias");	
		
		// send to clipboard
		widget.system("/bin/echo -n '"+alias.toString()+"@"+domain.toString()+"' | /usr/bin/pbcopy", null);
	}
}

function frontDomains_load()
{
	var myList = document.getElementById("frontDomains");
	myList.object.setOptions(listDomains);
	myList.object.setSelectedIndex(domainsIndex);
}


//
// Function: savePrefs()
// Saves the preferences. Called by showFront() (when clicking on back.done button)
//
function savePrefs()
{
//	alert("savePrefs()");
	if (window.widget)
	{

		var myList = document.getElementById("backDomains");
		domainsIndex = myList.options.selectedIndex;
		widget.setPreferenceForKey(domainsIndex, makeKey("dh-domainsIndex"));

		forwardDefault = document.getElementById("backForward").value;
		widget.setPreferenceForKey(forwardDefault, makeKey("dh-forwardDefault"));
		document.getElementById("frontForward").value = forwardDefault;
		
		frontDomains_load();

	}
}


//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    widget.setPreferenceForKey(null, makeKey("dh-username"));
	widget.setPreferenceForKey(null, makeKey("dh-domainsIndex"));
	widget.setPreferenceForKey(null, makeKey("dh-forwardDefault"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";
	
	// if we are not configured, disable done button...
	document.getElementById("done").object.enabled = configured;

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

	if (configured)
	{
		frontEnabled(1);
		document.getElementById("frontError").innerText = "";
	}
	savePrefs();
	frontSpinner.stop();

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}


if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}


/* Utilities */

// makeKey makes the widget multi-instance aware
function makeKey(key)
{
	return (widget.identifier + "-" + key);
//	return (key);
}

// Removes leading whitespaces
function LTrim( value ) {
	var re = /\s*((\S+\s*)*)/;
	return value.replace(re, "$1");
}

// Removes ending whitespaces
function RTrim( value ) {
	var re = /((\s*\S+)*)\s*/;
	return value.replace(re, "$1");
}

// Removes leading and ending whitespaces
function trim( value ) {
	return LTrim(RTrim(value));
}

// Get a property
function getPlistProperty(filename, property){
	
	// check the parameters
	if( (filename == null) || (filename == "") ){ return null; }
	if( (property == null) || (property == "") ){ return null; }
	
	// retrieve the value with the defaults command
	return trim(widget.system('/bin/sh -c "defaults read `pwd`/'+ filename + ' ' + property + '"',null).outputString);
}

function encode(data) {
	return (data.toJSON());
}

function decode(encoded_data) {
	var data = encoded_data.evalJSON();
	return (data.toArray());
}

